/*
  File name: CCytadelaConfig.h
  Copyright: (C) 2006 - 2007 Tomasz Kazmierczak

  Creation date: 14.09.2006 17:29
  Last modification date: 28.08.2007

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

*/

#ifndef _CCYTADELACONFIG_H_
#define _CCYTADELACONFIG_H_

#include <stdint.h>
#include <stdio.h>

class CCytadelaConfig {
private:
	//settings
	int32_t  mScreenSize[2];
	float    mGameSpeed;
	float    mMouseSpeed;
	char     mLocalization[FILENAME_MAX];
	bool     mDifficult;
	//other variables
	//game speed related
	int32_t  mGameSpeedSetting;
	int32_t  mNumOfGameSpeedSettings;
	float   *mGameSpeedSettings;
	//mouse speed related
	int32_t  mMouseSpeedSetting;
	int32_t  mNumOfMouseSpeedSettings;
	float   *mMouseSpeedSettings;
	//path to sys/ directory
	char     mConfigFilePath[FILENAME_MAX];

public:
	CCytadelaConfig(char *szSysDirPath);
	~CCytadelaConfig();

	//get settings
	const int32_t  *getScreenSize() { return mScreenSize; };
	const char *getLocalization() { return mLocalization; };
	bool isDifficult() { return mDifficult; };
	float getGameSpeed() { return mGameSpeed; };
	float getMouseSpeed() { return mMouseSpeed; };

	//set settings
	void setScreenSize(int32_t iWidth, int32_t iHeight);
	void setLocalization(char *szLocalization);
	void setDifficult(bool status) { mDifficult = status; };

	//other functions
	void setNextGameSpeed();
	void setPrevGameSpeed();
	void setNextMouseSpeed();
	void setPrevMouseSpeed();
};

#endif // _CCYTADELACONFIG_H_
